Index: /palm/trunk/SOURCE/poismg.f90
===================================================================
--- /palm/trunk/SOURCE/poismg.f90	(revision 1352)
+++ /palm/trunk/SOURCE/poismg.f90	(revision 1353)
@@ -23,5 +23,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -166,5 +166,5 @@
     ENDIF
 
-    p3 = 0.0
+    p3 = 0.0_wp
  
 !
@@ -185,8 +185,8 @@
     IF ( mg_cycles == -1 )  THEN
        maximum_mgcycles = 0
-       residual_norm    = 1.0 
+       residual_norm    = 1.0_wp
     ELSE
        maximum_mgcycles = mg_cycles
-       residual_norm    = 0.0
+       residual_norm    = 0.0_wp
     ENDIF
 
@@ -334,5 +334,5 @@
 !
 !--          Residual within topography should be zero
-             r(k,j,i) = r(k,j,i) * ( 1.0 - IBITS( flags(k,j,i), 6, 1 ) )
+             r(k,j,i) = r(k,j,i) * ( 1.0_wp - IBITS( flags(k,j,i), 6, 1 ) )
           ENDDO
        ENDDO
@@ -361,5 +361,5 @@
        r(nzb,:,: ) = r(nzb+1,:,:)
     ELSE
-       r(nzb,:,: ) = 0.0
+       r(nzb,:,: ) = 0.0_wp
     ENDIF
 
@@ -367,5 +367,5 @@
        r(nzt_mg(l)+1,:,: ) = r(nzt_mg(l),:,:)
     ELSE
-       r(nzt_mg(l)+1,:,: ) = 0.0
+       r(nzt_mg(l)+1,:,: ) = 0.0_wp
     ENDIF
 
@@ -508,39 +508,39 @@
                                         ( r(k,j,i) - r(k-1,j+1,i+1) )
 
-             f_mg(kc,jc,ic) = 1.0 / 64.0_wp * (                         &
-                              8.0 * r(k,j,i)                            &
-                            + 4.0 * ( rkjim   + rkjip   +               &
-                                      rkjpi   + rkjmi   )               &
-                            + 2.0 * ( rkjmim  + rkjpim  +               &
-                                      rkjmip  + rkjpip  )               &
-                            + 4.0 * rkmji                               &
-                            + 2.0 * ( rkmjim  + rkmjim  +               &
-                                      rkmjpi  + rkmjmi  )               &
-                            +       ( rkmjmim + rkmjpim +               &
-                                      rkmjmip + rkmjpip )               &
-                            + 4.0 * r(k+1,j,i)                          &
-                            + 2.0 * ( r(k+1,j,i-1)   + r(k+1,j,i+1)   + &
-                                      r(k+1,j+1,i)   + r(k+1,j-1,i)   ) &
-                            +       ( r(k+1,j-1,i-1) + r(k+1,j+1,i-1) + &
-                                      r(k+1,j-1,i+1) + r(k+1,j+1,i+1) ) &
-                                              )
-
-!             f_mg(kc,jc,ic) = 1.0 / 64.0_wp * (                         &
-!                              8.0 * r(k,j,i)                            &
-!                            + 4.0 * ( r(k,j,i-1)     + r(k,j,i+1)     + &
-!                                      r(k,j+1,i)     + r(k,j-1,i)     ) &
-!                            + 2.0 * ( r(k,j-1,i-1)   + r(k,j+1,i-1)   + &
-!                                      r(k,j-1,i+1)   + r(k,j+1,i+1)   ) &
-!                            + 4.0 * r(k-1,j,i)                          &
-!                            + 2.0 * ( r(k-1,j,i-1)   + r(k-1,j,i+1)   + &
-!                                      r(k-1,j+1,i)   + r(k-1,j-1,i)   ) &
-!                            +       ( r(k-1,j-1,i-1) + r(k-1,j+1,i-1) + &
-!                                      r(k-1,j-1,i+1) + r(k-1,j+1,i+1) ) &
-!                            + 4.0 * r(k+1,j,i)                          &
-!                            + 2.0 * ( r(k+1,j,i-1)   + r(k+1,j,i+1)   + &
-!                                      r(k+1,j+1,i)   + r(k+1,j-1,i)   ) &
-!                            +       ( r(k+1,j-1,i-1) + r(k+1,j+1,i-1) + &
-!                                      r(k+1,j-1,i+1) + r(k+1,j+1,i+1) ) &
-!                                              )
+             f_mg(kc,jc,ic) = 1.0_wp / 64.0_wp * (                         &
+                              8.0_wp * r(k,j,i)                            &
+                            + 4.0_wp * ( rkjim   + rkjip   +               &
+                                         rkjpi   + rkjmi   )               &
+                            + 2.0_wp * ( rkjmim  + rkjpim  +               &
+                                         rkjmip  + rkjpip  )               &
+                            + 4.0_wp * rkmji                               &
+                            + 2.0_wp * ( rkmjim  + rkmjim  +               &
+                                         rkmjpi  + rkmjmi  )               &
+                            +          ( rkmjmim + rkmjpim +               &
+                                         rkmjmip + rkmjpip )               &
+                            + 4.0_wp * r(k+1,j,i)                          &
+                            + 2.0_wp * ( r(k+1,j,i-1)   + r(k+1,j,i+1)   + &
+                                         r(k+1,j+1,i)   + r(k+1,j-1,i)   ) &
+                            +          ( r(k+1,j-1,i-1) + r(k+1,j+1,i-1) + &
+                                         r(k+1,j-1,i+1) + r(k+1,j+1,i+1) ) &
+                                                 )
+
+!             f_mg(kc,jc,ic) = 1.0_wp / 64.0_wp * (                         &
+!                              8.0_wp * r(k,j,i)                            &
+!                            + 4.0_wp * ( r(k,j,i-1)     + r(k,j,i+1)     + &
+!                                         r(k,j+1,i)     + r(k,j-1,i)     ) &
+!                            + 2.0_wp * ( r(k,j-1,i-1)   + r(k,j+1,i-1)   + &
+!                                         r(k,j-1,i+1)   + r(k,j+1,i+1)   ) &
+!                            + 4.0_wp * r(k-1,j,i)                          &
+!                            + 2.0_wp * ( r(k-1,j,i-1)   + r(k-1,j,i+1)   + &
+!                                         r(k-1,j+1,i)   + r(k-1,j-1,i)   ) &
+!                            +          ( r(k-1,j-1,i-1) + r(k-1,j+1,i-1) + &
+!                                         r(k-1,j-1,i+1) + r(k-1,j+1,i+1) ) &
+!                            + 4.0_wp * r(k+1,j,i)                          &
+!                            + 2.0_wp * ( r(k+1,j,i-1)   + r(k+1,j,i+1)   + &
+!                                         r(k+1,j+1,i)   + r(k+1,j-1,i)   ) &
+!                            +          ( r(k+1,j-1,i-1) + r(k+1,j+1,i-1) + &
+!                                         r(k+1,j-1,i+1) + r(k+1,j+1,i+1) ) &
+!                                                )
           ENDDO
        ENDDO
@@ -569,5 +569,5 @@
        f_mg(nzb,:,: ) = f_mg(nzb+1,:,:)
     ELSE
-       f_mg(nzb,:,: ) = 0.0
+       f_mg(nzb,:,: ) = 0.0_wp
     ENDIF
 
@@ -575,5 +575,5 @@
        f_mg(nzt_mg(l)+1,:,: ) = f_mg(nzt_mg(l),:,:)
     ELSE
-       f_mg(nzt_mg(l)+1,:,: ) = 0.0
+       f_mg(nzt_mg(l)+1,:,: ) = 0.0_wp
     ENDIF
 
@@ -634,22 +634,22 @@
 ! 
 !--          Points between two coarse-grid points
-             temp(2*k-1,2*j,2*i+1) = 0.5 * ( p(k,j,i) + p(k,j,i+1) )
-             temp(2*k-1,2*j+1,2*i) = 0.5 * ( p(k,j,i) + p(k,j+1,i) )
-             temp(2*k,2*j,2*i)     = 0.5 * ( p(k,j,i) + p(k+1,j,i) )
+             temp(2*k-1,2*j,2*i+1) = 0.5_wp * ( p(k,j,i) + p(k,j,i+1) )
+             temp(2*k-1,2*j+1,2*i) = 0.5_wp * ( p(k,j,i) + p(k,j+1,i) )
+             temp(2*k,2*j,2*i)     = 0.5_wp * ( p(k,j,i) + p(k+1,j,i) )
 !
 !--          Points in the center of the planes stretched by four points
 !--          of the coarse grid cube
-             temp(2*k-1,2*j+1,2*i+1) = 0.25 * ( p(k,j,i)   + p(k,j,i+1) + &
-                                                p(k,j+1,i) + p(k,j+1,i+1) )
-             temp(2*k,2*j,2*i+1)     = 0.25 * ( p(k,j,i)   + p(k,j,i+1) + &
-                                                p(k+1,j,i) + p(k+1,j,i+1) )
-             temp(2*k,2*j+1,2*i)     = 0.25 * ( p(k,j,i)   + p(k,j+1,i) + &
-                                                p(k+1,j,i) + p(k+1,j+1,i) )
+             temp(2*k-1,2*j+1,2*i+1) = 0.25_wp * ( p(k,j,i)   + p(k,j,i+1) + &
+                                                   p(k,j+1,i) + p(k,j+1,i+1) )
+             temp(2*k,2*j,2*i+1)     = 0.25_wp * ( p(k,j,i)   + p(k,j,i+1) + &
+                                                   p(k+1,j,i) + p(k+1,j,i+1) )
+             temp(2*k,2*j+1,2*i)     = 0.25_wp * ( p(k,j,i)   + p(k,j+1,i) + &
+                                                   p(k+1,j,i) + p(k+1,j+1,i) )
 !
 !--          Points in the middle of coarse grid cube
-             temp(2*k,2*j+1,2*i+1) = 0.125 * ( p(k,j,i)     + p(k,j,i+1)   + &
-                                               p(k,j+1,i)   + p(k,j+1,i+1) + &
-                                               p(k+1,j,i)   + p(k+1,j,i+1) + &
-                                               p(k+1,j+1,i) + p(k+1,j+1,i+1) )
+             temp(2*k,2*j+1,2*i+1) = 0.125_wp * ( p(k,j,i)     + p(k,j,i+1)   + &
+                                                  p(k,j+1,i)   + p(k,j+1,i+1) + &
+                                                  p(k+1,j,i)   + p(k+1,j,i+1) + &
+                                                  p(k+1,j+1,i) + p(k+1,j+1,i+1) )
           ENDDO
        ENDDO
@@ -676,5 +676,5 @@
        temp(nzb,:,: ) = temp(nzb+1,:,:)
     ELSE
-       temp(nzb,:,: ) = 0.0
+       temp(nzb,:,: ) = 0.0_wp
     ENDIF
 
@@ -682,5 +682,5 @@
        temp(nzt_mg(l)+1,:,: ) = temp(nzt_mg(l),:,:)
     ELSE
-       temp(nzt_mg(l)+1,:,: ) = 0.0
+       temp(nzt_mg(l)+1,:,: ) = 0.0_wp
     ENDIF
 
@@ -791,5 +791,5 @@
                 DO  j = nys_mg(l) + 2 - color, nyn_mg(l), 2 
                    DO  k = nzb+1, nzt_mg(l), 2
-!                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+!                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
 !                                ddx2_mg(l) * ( p_mg(k,j,i+1) + p_mg(k,j,i-1) ) &
 !                              + ddy2_mg(l) * ( p_mg(k,j+1,i) + p_mg(k,j-1,i) ) &
@@ -798,5 +798,5 @@
 !                                                       )
 
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -821,5 +821,5 @@
                 DO  j = nys_mg(l) + (color-1), nyn_mg(l), 2
                    DO  k = nzb+1, nzt_mg(l), 2 
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -844,5 +844,5 @@
                 DO  j = nys_mg(l) + (color-1), nyn_mg(l), 2
                    DO  k = nzb+2, nzt_mg(l), 2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -867,5 +867,5 @@
                 DO  j = nys_mg(l) + 2 - color, nyn_mg(l), 2
                    DO  k = nzb+2, nzt_mg(l), 2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -899,5 +899,5 @@
                    DO  k = nzb+1, nzt_mg(l), 2
                       j = jj
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -916,5 +916,5 @@
                            - f_mg(k,j,i)               )
                       j = jj+2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -938,5 +938,5 @@
                    DO  k = nzb+1, nzt_mg(l), 2 
                       j =jj
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -955,5 +955,5 @@
                            - f_mg(k,j,i)               )
                       j = jj+2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -977,5 +977,5 @@
                    DO  k = nzb+2, nzt_mg(l), 2
                       j =jj
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -994,5 +994,5 @@
                            - f_mg(k,j,i)               )
                       j = jj+2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -1016,5 +1016,5 @@
                    DO  k = nzb+2, nzt_mg(l), 2
                       j =jj
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -1033,5 +1033,5 @@
                            - f_mg(k,j,i)               )
                       j = jj+2
-                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
+                      p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
                              ddx2_mg(l) *                                      &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
@@ -1084,5 +1084,5 @@
              p_mg(nzb,:,: ) = p_mg(nzb+1,:,:)
           ELSE
-             p_mg(nzb,:,: ) = 0.0
+             p_mg(nzb,:,: ) = 0.0_wp
           ENDIF
 
@@ -1090,5 +1090,5 @@
              p_mg(nzt_mg(l)+1,:,: ) = p_mg(nzt_mg(l),:,:)
           ELSE
-             p_mg(nzt_mg(l)+1,:,: ) = 0.0
+             p_mg(nzt_mg(l)+1,:,: ) = 0.0_wp
           ENDIF
 
@@ -1106,5 +1106,5 @@
 !
 !--          First, set pressure inside topography to zero
-             p_mg(k,j,i) = p_mg(k,j,i) * ( 1.0 - IBITS( flags(k,j,i), 6, 1 ) )
+             p_mg(k,j,i) = p_mg(k,j,i) * ( 1.0_wp - IBITS( flags(k,j,i), 6, 1 ) )
 !
 !--          Second, determine if the gridpoint inside topography is adjacent
@@ -1119,11 +1119,11 @@
                           wall_top
 
-             IF ( wall_total > 0.0 )  THEN
-                p_mg(k,j,i) = 1.0 / wall_total *                 &
-                                  ( wall_left  * p_mg(k,j,i-1) + &
-                                    wall_right * p_mg(k,j,i+1) + &
-                                    wall_south * p_mg(k,j-1,i) + &
-                                    wall_north * p_mg(k,j+1,i) + &
-                                    wall_top   * p_mg(k+1,j,i) )
+             IF ( wall_total > 0.0_wp )  THEN
+                p_mg(k,j,i) = 1.0_wp / wall_total *                 &
+                                     ( wall_left  * p_mg(k,j,i-1) + &
+                                       wall_right * p_mg(k,j,i+1) + &
+                                       wall_south * p_mg(k,j-1,i) + &
+                                       wall_north * p_mg(k,j+1,i) + &
+                                       wall_top   * p_mg(k+1,j,i) )
              ENDIF
           ENDDO
@@ -1182,5 +1182,5 @@
     CALL cpu_log( log_point_s(34), 'mg_gather', 'start' )
 
-    f2_l = 0.0
+    f2_l = 0.0_wp
 
 !
@@ -1456,5 +1456,5 @@
        ENDIF
 
-       p2 = 0.0
+       p2 = 0.0_wp
 
 !
Index: /palm/trunk/SOURCE/production_e.f90
===================================================================
--- /palm/trunk/SOURCE/production_e.f90	(revision 1352)
+++ /palm/trunk/SOURCE/production_e.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute
 ! 
 ! Former revisions:
@@ -647,7 +647,7 @@
                             temp  = theta * t_d_pt(k)
                             k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *               &
-                                          ( q(k,j,i) - ql(k,j,i) ) *          &
-                                 ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                                 ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
+                                          ( q(k,j,i) - ql(k,j,i) ) *           &
+                                 ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /      &
+                                 ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *        &
                                  ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
                             k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
@@ -680,8 +680,8 @@
                             theta = pt(k,j,i) + pt_d_t(k) * l_d_cp * ql(k,j,i)
                             temp  = theta * t_d_pt(k)
-                            k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *                 &
-                                          ( q(k,j,i) - ql(k,j,i) ) *          &
-                                 ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /        &
-                                 ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *          &
+                            k1 = ( 1.0_wp - q(k,j,i) + 1.61_wp *               &
+                                          ( q(k,j,i) - ql(k,j,i) ) *           &
+                                 ( 1.0_wp + 0.622_wp * l_d_r / temp ) ) /      &
+                                 ( 1.0_wp + 0.622_wp * l_d_r * l_d_cp *        &
                                  ( q(k,j,i) - ql(k,j,i) ) / ( temp * temp ) )
                             k2 = theta * ( l_d_cp / temp * k1 - 1.0_wp )
@@ -1644,7 +1644,7 @@
              dwdz  =           ( w(k,j,i)   - w(k-1,j,i)   ) * ddzw(k)
 
-             def = 2.0 * ( dudx**2 + dvdy**2 + dwdz**2 ) +           &
+             def = 2.0_wp * ( dudx**2 + dvdy**2 + dwdz**2 ) +        &
                    dudy**2 + dvdx**2 + dwdx**2 + dwdy**2 + dudz**2 + &
-                   dvdz**2 + 2.0 * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
+                   dvdz**2 + 2.0_wp * ( dvdx*dudy + dwdx*dudz + dwdy*dvdz )
 
              IF ( def < 0.0_wp )  def = 0.0_wp
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1352)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! REAL constants provided with KIND-attribute
 ! 
 ! Former revisions:
@@ -1038,5 +1038,5 @@
     CALL cpu_log( log_point(7), 'w-equation', 'start' )
 
-    tend = 0.0
+    tend = 0.0_wp
     IF ( timestep_scheme(1:5) == 'runge' )  THEN
        IF ( ws_scheme_mom )  THEN
@@ -1121,5 +1121,5 @@
 !
 !--          Bott-Chlond scheme always uses Euler time step. Thus:
-             sbt = 1.0
+             sbt = 1.0_wp
           ENDIF
           tend = 0.0_wp
@@ -1230,5 +1230,5 @@
 !
 !--          Bott-Chlond scheme always uses Euler time step. Thus:
-             sbt = 1.0
+             sbt = 1.0_wp
           ENDIF
           tend = 0.0_wp
@@ -1240,5 +1240,5 @@
 !--    sa-tendency terms with no communication
        IF ( scalar_advec /= 'bc-scheme' )  THEN
-          tend = 0.0
+          tend = 0.0_wp
           IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_sca )  THEN
@@ -1755,5 +1755,5 @@
 !
 !--          Bott-Chlond scheme always uses Euler time step. Thus:
-             sbt = 1.0
+             sbt = 1.0_wp
           ENDIF
           tend = 0.0_wp
Index: /palm/trunk/SOURCE/run_control.f90
===================================================================
--- /palm/trunk/SOURCE/run_control.f90	(revision 1352)
+++ /palm/trunk/SOURCE/run_control.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -67,4 +67,6 @@
     USE indices,                                                               &
         ONLY:  nzb
+
+    USE kinds
 
     USE pegrid
@@ -118,6 +120,6 @@
                           hom(nzb+10,1,pr_palm,0), u_max_ijk(1:3),             &
                           v_max_ijk(1:3), w_max_ijk(1:3),                      &
-                          advected_distance_x/1000.0,                          &
-                          advected_distance_y/1000.0, mgcycles
+                          advected_distance_x/1000.0_wp,                       &
+                          advected_distance_y/1000.0_wp, mgcycles
 !
 !--    Write buffer contents to disc immediately
Index: /palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90
===================================================================
--- /palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90	(revision 1352)
+++ /palm/trunk/SOURCE/set_slicer_attributes_dvrp.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -69,5 +69,5 @@
     minv = slicer_range_limits_dvrp(1,n_slicer)
     maxv = slicer_range_limits_dvrp(2,n_slicer)
-    meav = ( minv + maxv ) * 0.5
+    meav = ( minv + maxv ) * 0.5_wp
 
 !
@@ -75,13 +75,13 @@
 !-- This table ranges from deep blue (min) to deep red (max)
     DO  j = 1, 50
-       interval_values_dvrp(1,j) = minv + (meav-minv) * (j-1.0) / 50.0
-       interval_values_dvrp(2,j) = minv + (meav-minv) * (  j  ) / 50.0
-       interval_h_dvrp(:,j) = 270.0 - ( j - 1.0 ) * 90.0 / 49.0
+       interval_values_dvrp(1,j) = minv + (meav-minv) * ( j - 1.0_wp ) / 50.0_wp
+       interval_values_dvrp(2,j) = minv + (meav-minv) * ( j )          / 50.0_wp
+       interval_h_dvrp(:,j) = 270.0_wp - ( j - 1.0_wp ) * 90.0_wp / 49.0_wp
     ENDDO
 
     DO  j = 51, 100
-       interval_values_dvrp(1,j) = meav + (maxv-meav) * (j-51.0) / 50.0
-       interval_values_dvrp(2,j) = meav + (maxv-meav) * (j-50.0) / 50.0
-       interval_h_dvrp(:,j) = 70.0 - ( j - 51.0 ) * 90.0 / 49.0
+       interval_values_dvrp(1,j) = meav + (maxv-meav) * ( j - 51.0_wp ) / 50.0_wp
+       interval_values_dvrp(2,j) = meav + (maxv-meav) * ( j - 50.0_wp ) / 50.0_wp
+       interval_h_dvrp(:,j) = 70.0_wp - ( j - 51.0_wp ) * 90.0_wp / 49.0_wp
     ENDDO
 
Index: /palm/trunk/SOURCE/sor.f90
===================================================================
--- /palm/trunk/SOURCE/sor.f90	(revision 1352)
+++ /palm/trunk/SOURCE/sor.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-!
+! REAL constants provided with KIND-attribute
 !
 ! Former revisions:
@@ -88,5 +88,5 @@
          f2(k) = ddzu(k+1) * ddzw(k)
          f3(k) = ddzu(k)   * ddzw(k)
-         f1(k) = 2.0 * ( ddx2 + ddy2 ) + f2(k) + f3(k)
+         f1(k) = 2.0_wp * ( ddx2 + ddy2 ) + f2(k) + f3(k)
     ENDDO
 
@@ -195,5 +195,5 @@
           p(nzb,:,:) = p(nzb+1,:,:)
        ELSE                            !       Dirichlet
-          p(nzb,:,:) = 0.0
+          p(nzb,:,:) = 0.0_wp
        ENDIF
 
@@ -203,5 +203,5 @@
           p(nzt+1,:,:) = p(nzt,:,:)
        ELSE                      !  Dirichlet
-          p(nzt+1,:,:) = 0.0
+          p(nzt+1,:,:) = 0.0_wp
        ENDIF
 
Index: /palm/trunk/SOURCE/subsidence.f90
===================================================================
--- /palm/trunk/SOURCE/subsidence.f90	(revision 1352)
+++ /palm/trunk/SOURCE/subsidence.f90	(revision 1353)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! REAL constants provided with KIND-attribute
 ! 
 ! Former revisions:
@@ -89,5 +89,5 @@
        IF ( .NOT. ALLOCATED( w_subs )) THEN
           ALLOCATE( w_subs(nzb:nzt+1) )
-          w_subs = 0.0
+          w_subs = 0.0_wp
        ENDIF 
 
@@ -102,6 +102,6 @@
 !--   using the given gradients
       i = 1
-      gradient = 0.0
-      ws_surface = 0.0
+      gradient = 0.0_wp
+      ws_surface = 0.0_wp
       
 
@@ -110,15 +110,15 @@
          IF ( i < 11 ) THEN
             IF ( subs_vertical_gradient_level(i) < zu(k)  .AND. &
-                 subs_vertical_gradient_level(i) >= 0.0 )  THEN
-               gradient = subs_vertical_gradient(i) / 100.0
+                 subs_vertical_gradient_level(i) >= 0.0_wp )  THEN
+               gradient = subs_vertical_gradient(i) / 100.0_wp
                subs_vertical_gradient_level_i(i) = k - 1
                i = i + 1
             ENDIF
          ENDIF
-         IF ( gradient /= 0.0 )  THEN
+         IF ( gradient /= 0.0_wp )  THEN
             IF ( k /= 1 )  THEN
                w_subs(k) = w_subs(k-1) + dzu(k) * gradient
             ELSE
-               w_subs(k) = ws_surface   + 0.5 * dzu(k) * gradient
+               w_subs(k) = ws_surface   + 0.5_wp * dzu(k) * gradient
             ENDIF
          ELSE
@@ -130,6 +130,6 @@
 !--   In case of no given gradients for the subsidence/ascent velocity,
 !--   choose zero gradient
-      IF ( subs_vertical_gradient_level(1) == -9999999.9 )  THEN
-         subs_vertical_gradient_level(1) = 0.0
+      IF ( subs_vertical_gradient_level(1) == -9999999.9_wp )  THEN
+         subs_vertical_gradient_level(1) = 0.0_wp
       ENDIF
 
@@ -171,5 +171,5 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt 
-                IF ( w_subs(k) < 0.0 ) THEN    ! large-scale subsidence
+                IF ( w_subs(k) < 0.0_wp ) THEN    ! large-scale subsidence
                    tendency(k,j,i) = tendency(k,j,i) - w_subs(k) *  &
                                      ( var(k+1,j,i) - var(k,j,i) ) * ddzu(k+1)
@@ -187,5 +187,5 @@
 
        DO  k = nzb, nzt
-          IF ( w_subs(k) < 0.0 ) THEN      ! large-scale subsidence
+          IF ( w_subs(k) < 0.0_wp ) THEN      ! large-scale subsidence
              var_mod(k) = var_init(k) - dt_3d * w_subs(k) *  &
                                ( var_init(k+1) - var_init(k) ) * ddzu(k+1)
@@ -195,5 +195,5 @@
 !--   At the upper boundary, the initial profile is shifted with aid of 
 !--   the gradient tmp_grad. (This is ok if the gradients are linear.)
-      IF ( w_subs(nzt) < 0.0 ) THEN
+      IF ( w_subs(nzt) < 0.0_wp ) THEN
          tmp_grad = ( var_init(nzt+1) - var_init(nzt) ) * ddzu(nzt+1)
          var_mod(nzt+1) = var_init(nzt+1) -  &
@@ -203,5 +203,5 @@
 
       DO  k = nzt+1, nzb+1, -1
-         IF ( w_subs(k) >= 0.0 ) THEN  ! large-scale ascent
+         IF ( w_subs(k) >= 0.0_wp ) THEN  ! large-scale ascent
             var_mod(k) = var_init(k) - dt_3d * w_subs(k) *  &
                                ( var_init(k) - var_init(k-1) ) * ddzu(k) 
@@ -213,5 +213,5 @@
 
 
-      IF ( w_subs(nzb+1) >= 0.0 ) THEN
+      IF ( w_subs(nzb+1) >= 0.0_wp ) THEN
          var_mod(nzb) = var_init(nzb)
       ENDIF
@@ -253,5 +253,5 @@
 !--    Influence of w_subsidence on the current tendency term
        DO  k = nzb_s_inner(j,i)+1, nzt 
-          IF ( w_subs(k) < 0.0 ) THEN      ! large-scale subsidence
+          IF ( w_subs(k) < 0.0_wp ) THEN      ! large-scale subsidence
              tendency(k,j,i) = tendency(k,j,i) - w_subs(k) *  &
                                ( var(k+1,j,i) - var(k,j,i) ) * ddzu(k+1)
@@ -269,5 +269,5 @@
 
           DO  k = nzb, nzt
-             IF ( w_subs(k) < 0.0 ) THEN      ! large-scale subsidence
+             IF ( w_subs(k) < 0.0_wp ) THEN      ! large-scale subsidence
                 var_mod(k) = var_init(k) - dt_3d * w_subs(k) *  &
                                   ( var_init(k+1) - var_init(k) ) * ddzu(k+1)
@@ -277,5 +277,5 @@
 !--       At the upper boundary, the initial profile is shifted with aid of 
 !--       the gradient tmp_grad. (This is ok if the gradients are linear.)
-          IF ( w_subs(nzt) < 0.0 ) THEN
+          IF ( w_subs(nzt) < 0.0_wp ) THEN
              tmp_grad = ( var_init(nzt+1) - var_init(nzt) ) * ddzu(nzt+1)
              var_mod(nzt+1) = var_init(nzt+1) -  &
@@ -285,5 +285,5 @@
 
           DO  k = nzt+1, nzb+1, -1
-             IF ( w_subs(k) >= 0.0 ) THEN  ! large-scale ascent
+             IF ( w_subs(k) >= 0.0_wp ) THEN  ! large-scale ascent
                 var_mod(k) = var_init(k) - dt_3d * w_subs(k) *  &
                                    ( var_init(k) - var_init(k-1) ) * ddzu(k)
@@ -295,5 +295,5 @@
 
 
-          IF ( w_subs(nzb+1) >= 0.0 ) THEN
+          IF ( w_subs(nzb+1) >= 0.0_wp ) THEN
              var_mod(nzb) = var_init(nzb)
           ENDIF
